3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
39 OK_TO_SKIP_PRE_REBASE
=
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
49 dotest
="$GIT_DIR"/rebase-merge
53 test "$(git config --bool rebase.stat)" = true
&& diffstat
=t
57 allow_rerere_autoupdate
=
60 test -n "$prev_head" || die
"prev_head must be defined"
61 test -d "$dotest" || die
"$dotest directory does not exist"
63 unmerged
=$
(git ls-files
-u)
64 if test -n "$unmerged"
66 echo "You still have unmerged paths in your index"
67 echo "did you forget to use git add?"
71 cmt
=`cat "$dotest/current"`
72 if ! git diff-index
--quiet --ignore-submodules HEAD
--
74 if ! git commit
--no-verify -C "$cmt"
76 echo "Commit failed, please do not call \"git commit\""
77 echo "directly, but instead do one of the following: "
80 if test -z "$GIT_QUIET"
82 printf "Committed: %0${prec}d " $msgnum
84 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
86 if test -z "$GIT_QUIET"
88 printf "Already applied: %0${prec}d " $msgnum
91 test -z "$GIT_QUIET" &&
92 GIT_PAGER
='' git log
--format=%s
-1 "$cmt"
94 prev_head
=`git rev-parse HEAD^0`
95 # save the resulting commit so we can read-tree on it later
96 echo "$prev_head" > "$dotest/prev_head"
98 # onto the next patch:
99 msgnum
=$
(($msgnum + 1))
100 echo "$msgnum" >"$dotest/msgnum"
104 cmt
="$(cat "$dotest/cmt.
$1")"
105 echo "$cmt" > "$dotest/current"
106 hd
=$
(git rev-parse
--verify HEAD
)
107 cmt_name
=$
(git symbolic-ref HEAD
2> /dev
/null ||
echo HEAD
)
108 msgnum
=$
(cat "$dotest/msgnum")
109 end
=$
(cat "$dotest/end")
110 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
111 eval GITHEAD_
$hd='$(cat "$dotest/onto_name")'
112 export GITHEAD_
$cmt GITHEAD_
$hd
113 if test -n "$GIT_QUIET"
115 GIT_MERGE_VERBOSITY
=1 && export GIT_MERGE_VERBOSITY
117 eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
121 unset GITHEAD_
$cmt GITHEAD_
$hd
125 git rerere
$allow_rerere_autoupdate
129 echo "Strategy: $rv $strategy failed, try another" 1>&2
133 die
"Unknown exit code ($rv) from command:" \
134 "git-merge-$strategy $cmt^ -- HEAD $cmt"
139 move_to_original_branch
() {
140 test -z "$head_name" &&
141 head_name
="$(cat "$dotest"/head-name)" &&
142 onto
="$(cat "$dotest"/onto)" &&
143 orig_head
="$(cat "$dotest"/orig-head)"
146 message
="rebase finished: $head_name onto $onto"
147 git update-ref
-m "$message" \
148 $head_name $
(git rev-parse HEAD
) $orig_head &&
149 git symbolic-ref HEAD
$head_name ||
150 die
"Could not move back to $head_name"
156 move_to_original_branch
157 git notes copy
--for-rewrite=rebase
< "$dotest"/rewritten
158 if test -x "$GIT_DIR"/hooks
/post-rewrite
&&
159 test -s "$dotest"/rewritten
; then
160 "$GIT_DIR"/hooks
/post-rewrite rebase
< "$dotest"/rewritten
171 interactive_rebase
=explicit
174 -p|
--preserve-merges)
175 interactive_rebase
=implied
181 if [ "$interactive_rebase" = implied
]; then
186 test -n "$interactive_rebase" ||
test -f "$dotest"/interactive
189 run_pre_rebase_hook
() {
190 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
191 test -x "$GIT_DIR/hooks/pre-rebase"
193 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
194 die
"The pre-rebase hook refused to rebase."
198 test -f "$GIT_DIR"/rebase-apply
/applying
&&
199 die
'It looks like git-am is in progress. Cannot rebase.'
201 is_interactive
"$@" && exec git-rebase--interactive
"$@"
207 OK_TO_SKIP_PRE_REBASE
=yes
210 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
211 die
"No rebase in progress?"
213 git update-index
--ignore-submodules --refresh &&
214 git diff-files
--quiet --ignore-submodules ||
{
215 echo "You must edit all merge conflicts and then"
216 echo "mark them as resolved using git add"
221 prev_head
=$
(cat "$dotest/prev_head")
222 end
=$
(cat "$dotest/end")
223 msgnum
=$
(cat "$dotest/msgnum")
224 onto
=$
(cat "$dotest/onto")
225 GIT_QUIET
=$
(cat "$dotest/quiet")
227 while test "$msgnum" -le "$end"
235 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
236 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
237 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
238 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
239 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" &&
240 move_to_original_branch
244 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
245 die
"No rebase in progress?"
247 git
reset --hard HEAD ||
exit $?
251 prev_head
=$
(cat "$dotest/prev_head")
252 end
=$
(cat "$dotest/end")
253 msgnum
=$
(cat "$dotest/msgnum")
254 msgnum
=$
(($msgnum + 1))
255 onto
=$
(cat "$dotest/onto")
256 GIT_QUIET
=$
(cat "$dotest/quiet")
257 while test "$msgnum" -le "$end"
265 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
266 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
267 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
268 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
269 git am
-3 --skip --resolvemsg="$RESOLVEMSG" &&
270 move_to_original_branch
274 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
275 die
"No rebase in progress?"
280 GIT_QUIET
=$
(cat "$dotest/quiet")
281 move_to_original_branch
283 dotest
="$GIT_DIR"/rebase-apply
284 GIT_QUIET
=$
(cat "$dotest/quiet")
285 move_to_original_branch
287 git
reset --hard $
(cat "$dotest/orig-head")
292 test 2 -le "$#" || usage
296 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
299 -X*|
--strategy-option*)
301 1,-X|
1,--strategy-option)
303 *,-X|
*,--strategy-option)
306 *,--strategy-option=*)
307 newopt
="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
309 newopt
="$(expr " $1" : ' -X\(.*\)')" ;;
313 strategy_opts
="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
316 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
317 --strateg=*|
--strategy=*|\
318 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
321 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
343 git_am_opt
="$git_am_opt -q"
348 git_am_opt
="$git_am_opt $1"
350 --whitespace=fix|
--whitespace=strip
)
356 git_am_opt
="$git_am_opt $1"
358 --committer-date-is-author-date|
--ignore-date)
359 git_am_opt
="$git_am_opt $1"
363 git_am_opt
="$git_am_opt $1"
368 -f|
--f|
--fo|
--for|
--forc|
--force|
--force-r|
--force-re|
--force-reb|
--force-reba|
--force-rebas|
--force-rebase|
--no-ff)
371 --rerere-autoupdate|
--no-rerere-autoupdate)
372 allow_rerere_autoupdate
="$1"
383 test $# -gt 2 && usage
385 if test $# -eq 0 && test -z "$rebase_root"
387 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
388 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply
/rebasing
&&
389 die
'A rebase is in progress, try --continue, --skip or --abort.'
392 # Make sure we do not have $GIT_DIR/rebase-apply
393 if test -z "$do_merge"
395 if mkdir
"$GIT_DIR"/rebase-apply
2>/dev
/null
397 rmdir "$GIT_DIR"/rebase-apply
400 It seems that I cannot create a rebase-apply directory, and
401 I wonder if you are in the middle of patch application or another
402 rebase. If that is not the case, please
403 rm -fr '"$GIT_DIR"'/rebase-apply
404 and run me again. I am stopping in case you still have something
411 die
"previous rebase directory $dotest still exists." \
412 'Try git rebase (--continue | --abort | --skip)'
416 require_clean_work_tree
"rebase" "Please commit or stash them."
418 if test -z "$rebase_root"
420 # The upstream head must be given. Make sure it is valid.
423 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
424 die
"invalid upstream $upstream_name"
426 upstream_arg
="$upstream_name"
428 test -z "$newbase" && die
"--root must be used with --onto"
432 upstream_arg
="$root_flag"
435 # Make sure the branch to rebase onto is valid.
436 onto_name
=${newbase-"$upstream_name"}
439 if left
=${onto_name%...*} right
=${onto_name#*...} &&
440 onto
=$
(git merge-base
--all ${left:-HEAD} ${right:-HEAD})
444 die
"$onto_name: there are more than one merge bases"
447 die
"$onto_name: there is no merge base"
451 die
"$onto_name: there is no merge base"
455 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
459 # If a hook exists, give it a chance to interrupt
460 run_pre_rebase_hook
"$upstream_arg" "$@"
462 # If the branch to rebase is given, that is the branch we will rebase
463 # $branch_name -- branch being rebased, or HEAD (already detached)
464 # $orig_head -- commit object name of tip of the branch before rebasing
465 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
469 # Is it "rebase other $branchname" or "rebase other $commit"?
473 if git show-ref
--verify --quiet -- "refs/heads/$1" &&
474 branch
=$
(git rev-parse
-q --verify "refs/heads/$1")
476 head_name
="refs/heads/$1"
477 elif branch
=$
(git rev-parse
-q --verify "$1")
479 head_name
="detached HEAD"
485 # Do not need to switch branches, we are already on it.
486 if branch_name
=`git symbolic-ref -q HEAD`
488 head_name
=$branch_name
489 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
491 head_name
="detached HEAD"
492 branch_name
=HEAD
;# detached
494 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
499 # Now we are rebasing commits $upstream..$branch (or with --root,
500 # everything leading up to $branch) on top of $onto
502 # Check if we are already based on $onto with linear history,
503 # but this should be done only when upstream and onto are the same.
504 mb
=$
(git merge-base
"$onto" "$branch")
505 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
507 ! (git rev-list
--parents "$onto"..
"$branch" | sane_grep
" .* ") > /dev
/null
509 if test -z "$force_rebase"
511 # Lazily switch to the target branch if needed...
512 test -z "$switch_to" || git checkout
"$switch_to"
513 say
"Current branch $branch_name is up to date."
516 say
"Current branch $branch_name is up to date, rebase forced."
520 # Detach HEAD and reset the tree
521 say
"First, rewinding head to replay your work on top of it..."
522 git checkout
-q "$onto^0" || die
"could not detach HEAD"
523 git update-ref ORIG_HEAD
$branch
525 if test -n "$diffstat"
527 if test -n "$verbose"
529 echo "Changes from $mb to $onto:"
531 # We want color (if set), but no pager
532 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
535 # If the $onto is a proper descendant of the tip of the branch, then
536 # we just fast-forwarded.
537 if test "$mb" = "$branch"
539 say
"Fast-forwarded $branch_name to $onto_name."
540 move_to_original_branch
544 if test -n "$rebase_root"
546 revisions
="$onto..$orig_head"
548 revisions
="$upstream..$orig_head"
551 if test -z "$do_merge"
553 git format-patch
-k --stdout --full-index --ignore-if-in-upstream \
554 --src-prefix=a
/ --dst-prefix=b
/ \
555 --no-renames $root_flag "$revisions" |
556 git am
$git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
557 move_to_original_branch
559 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply
&&
560 echo $head_name > "$GIT_DIR"/rebase-apply
/head-name
&&
561 echo $onto > "$GIT_DIR"/rebase-apply
/onto
&&
562 echo $orig_head > "$GIT_DIR"/rebase-apply
/orig-head
&&
563 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply
/quiet
567 # start doing a rebase with git-merge
568 # this is rename-aware if the recursive (default) strategy is used
571 echo "$onto" > "$dotest/onto"
572 echo "$onto_name" > "$dotest/onto_name"
574 echo "$prev_head" > "$dotest/prev_head"
575 echo "$orig_head" > "$dotest/orig-head"
576 echo "$head_name" > "$dotest/head-name"
577 echo "$GIT_QUIET" > "$dotest/quiet"
580 for cmt
in `git rev-list --reverse --no-merges "$revisions"`
582 msgnum
=$
(($msgnum + 1))
583 echo "$cmt" > "$dotest/cmt.$msgnum"
586 echo 1 >"$dotest/msgnum"
587 echo $msgnum >"$dotest/end"
592 while test "$msgnum" -le "$end"